<template>
    <el-dialog title="选择商品" :visible.sync="dialogVisible" @close="reset" top="5vh">
        <el-form :model="searhForm" inline>
            <el-form-item>
                <el-input v-model="searhForm.name" placeholder="商品名称" @input="onInput"></el-input>
            </el-form-item>
            <el-form-item>
                <el-select v-model="searhForm.category" placeholder="商品分类">
                    <el-option :label="item.name" :value="item.id" v-for="item in categoryList"
                        :key="item.id"></el-option>
                </el-select>
            </el-form-item>
            <el-form-item>
                <el-button type="primary" @click="getTableData">查询</el-button>
                <el-button @click="resetHandle">重置</el-button>
            </el-form-item>
        </el-form>
        <div class="head-container">
            <el-table ref="table" :data="tableData.list" @select="firstSelectChange" v-loading="tableData.loading"
                :row-key="getRowKey" @selection-change="onSelectionChange">
                <el-table-column type="selection" width="55" align="center" :reserve-selection="true"></el-table-column>
                <el-table-column label="商品信息">
                    <template v-slot="scope">
                        <div class="shop_info">
                            <el-image :src="scope.row.coverImg" style="width: 30px;height: 30px;">
                                <div class="img_error" slot="error">
                                    <i class="icon el-icon-document-delete"></i>
                                </div>
                            </el-image>
                            <span>{{ scope.row.name }}</span>
                        </div>
                    </template>
                </el-table-column>
                <el-table-column label="规格">
                    <template v-slot="scope">
                        {{ scope.row.typeEnum }}
                    </template>
                </el-table-column> <el-table-column label="是否售罄">
                    <template v-slot="scope">
                        {{ scope.row.isPauseSale == 1 ? '是' : '否' }}
                    </template>
                </el-table-column> <el-table-column label="是否分销">
                    <template v-slot="scope">
                        {{ scope.row.isDistribute == 1 ? '是' : '否' }}
                    </template>
                </el-table-column>
                <el-table-column label="售价">
                    <template v-slot="scope">
                        ￥{{ scope.row.lowPrice }}
                    </template>
                </el-table-column>
                <el-table-column label="销量/库存">
                    <template v-slot="scope">
                        {{ scope.row.realSalesNumber }}/{{ scope.row.stockNumber }}
                    </template>
                </el-table-column>
                <el-table-column label="分类名称" prop="categoryName"></el-table-column>
            </el-table>
        </div>
        <el-pagination :total="tableData.total" :current-page="tableData.page + 1" :page-size="tableData.size"
            @current-change="paginationChange" @size-change="sizeChange"
            layout="total, sizes, prev, pager, next, jumper"></el-pagination>
        <span slot="footer" class="dialog-footer">
            <el-button @click="dialogVisible = false">取 消</el-button>
            <el-button type="primary" @click="confirmHandle">确 定</el-button>
        </span>
    </el-dialog>
</template>

<script>
import { tbShopCategoryGet, tbProductlist } from "@/api/invoicing";
import _ from 'lodash'
export default {
    data() {
        return {
            dialogVisible: false,
            searhForm: {
                name: '',
                category: ''
            },
            categoryList: [],
            tableData: {
                page: 0,
                size: 10,
                total: 0,
                loading: false,
                list: []
            },
            goods: [],
            // 是否单选
            isselect: false,
            stayselection: []//待确认
        }
    },
    methods: {
        reset(){
            this.$refs.table.clearSelection()
        },
        onInput: _.debounce(function (event) {//防抖请求
            this.getTableData()
        }, 500),
        onSelectionChange(selection) {
            this.stayselection = selection
        },
        getRowKey(row) {
            return row.id
        },
        firstSelectChange() {
            let selection = this.$refs.table.selection
            if (selection.length > 1 && this.isselect) {
                const del_row = selection.shift();
                this.$refs.table.toggleRowSelection(del_row, false);
            }
        },
        // 确定选商品
        confirmHandle() {
            // let res = this.$refs.table.selection
            var uniqueArray = this.stayselection.filter(item1 =>
                !this.goods.some(item2 => item2.productId == item1.id)
            );
            this.$emit('success', uniqueArray)
            this.close()
        },
        // 是否单选
        isselectEvent() {
            this.isselect = true
        },
        // 重置查询
        resetHandle() {
            this.searhForm.name = ''
            this.searhForm.category = ''
            this.tableData.page = 0
            this.tableData.size = 10
            this.tableData.list = []
            this.getTableData()
        },
        // 分页大小改变
        sizeChange(e) {
            this.tableData.size = e
            this.getTableData()
        },
        // 分页回调
        paginationChange(e) {
            this.tableData.page = e - 1
            this.getTableData()
        },
        // 商品列表
        async getTableData() {
            this.tableData.loading = true
            try {
                const res = await tbProductlist({
                    page: this.tableData.page,
                    size: this.tableData.size,
                    name: this.searhForm.name,
                    categoryId: this.searhForm.category,
                    shopId: localStorage.getItem('shopId'),
                    sort: 'id',
                })
                this.tableData.list = res.content
                this.tableData.total = res.totalElements

                if (this.goods.length) {
                    this.$nextTick(() => {
                        this.selection()
                    })
                }
                setTimeout(() => {
                    this.tableData.loading = false
                }, 500);
            } catch (error) {
                console.log(error)
            }
        },
        // 商品分类
        async tbShopCategoryGet() {
            try {
                const res = await tbShopCategoryGet({
                    page: 0,
                    size: 100,
                    sort: 'id',
                    shopId: localStorage.getItem('shopId')
                })
                this.categoryList = res.content
            } catch (error) {
                console.log(error)
            }
        },
        show(goods) {
            this.dialogVisible = true
            if (goods && goods.length) {
                this.goods = goods
            } else {
                this.goods = []
            }
            this.tbShopCategoryGet()
            this.resetHandle()
        },
        close() {
            this.dialogVisible = false
        },
        selection() {
            this.goods.forEach(row => {
                this.tableData.list.forEach((item, index) => {
                    if (row.id == item.id) {
                        this.$refs.table.toggleRowSelection(this.tableData.list[index]);
                    }
                })
            });
        }
    }
}
</script>

<style scoped lang="scss">
.head-container{
    max-height: 60vh;
    overflow-y: scroll;
}
.shop_info {
    display: flex;
    align-items: center;

    span {
        margin-left: 10px;
    }
}
</style>